function [ans]=main_function(input_pic_name)

%**************STAGE 1: PROCESSING CALIBRATION DATA(SURFACE EDGES IMAGES) TO A VALID INPUT FOR CURVES MAPPING FUNCTION******************************************************
     %reading calibreation inputs (surface curve's edges)
    
     %CALIBREATED PROJECTION SURFACE CURVES FILE NAMES: vertical,horizontal
     %edges_fname_hor='C:\MATLAB7\work\icbv project\interpolation samples\horizontal1.bmp';
     edges_fname_hor= 'C:\Documents and Settings\Dudu\Desktop\project logs\pre-processed calibration edge mapping input\curves\horizontal1.bmp';
    
    %edges_fname_ver= 'C:\MATLAB7\work\icbv project\interpolation samples\vertical1.bmp';
    edges_fname_ver= 'C:\Documents and Settings\Dudu\Desktop\project logs\pre-processed calibration edge mapping input\curves\vertical1.bmp';
    edges_fname_ver_img=imread(edges_fname_ver);
    edges_original_ver_img_transpose=edges_fname_ver_img';%DOING THE TRANSPOSITION ON VERTICAL CURVES
    
    %vertical curves transposition 
    %to use as a simple input for the curve mapping function
    
    edges_fname_ver_t= 'C:\Documents and Settings\Dudu\Desktop\project logs\processed calibration edges input\curves\vertical_t1.bmp';
    imwrite(edges_original_ver_img_transpose,edges_fname_ver_t);
    
    
     %ORIGINAL PROJECTION  SURFACE CURVES FILE NAMES: vertical,horizontal
    edges_fname_original_hor= 'C:\Documents and Settings\Dudu\Desktop\project logs\pre-processed calibration edge mapping input\original curves\horizontal original.bmp';
    %edges_fname_original_hor='C:\MATLAB7\work\icbv project\interpolation samples\horizontal original.bmp';
    edges_fname_original_ver= 'C:\Documents and Settings\Dudu\Desktop\project logs\pre-processed calibration edge mapping input\original curves\vertical original.bmp';
    %edges_fname_original_ver=  'C:\MATLAB7\work\icbv project\interpolation samples\vertical original.bmp';
  
   
   edges_fname_original_ver_img=imread(edges_fname_original_ver);
   
    %vertical lines/original curves transposition 
    %to use as a simple input for the curve mapping function
   edges_original_ver_img_transpose=edges_fname_original_ver_img';%DOING THE TRANSPOSITION ON VERTICAL ORIGINAL CURVES
   edges_fname_original_ver_t= 'C:\Documents and Settings\Dudu\Desktop\project logs\processed calibration edges input\original curves\vertical_t original.bmp';
   imwrite(edges_original_ver_img_transpose ,edges_fname_original_ver_t);
   
   
    
    %input_pic_name='C:\MATLAB7\work\icbv project\interpolation samples\Bump.bmp';
    input_pic_name ='C:\Documents and Settings\Dudu\Desktop\project logs\input resources\Bump.bmp';
    input_picture_matrix=imread(input_pic_name);
     [m_pic,n_pic]=size(input_picture_matrix);
  %***********STAGE 2: MAPPING DEVIATIVE SURFACE CURVES AND CALCULATION OF THIER COUNTER CURVES*****************************************************

 

 H_matrix=surface_edges_mapping_and_dev_calc(edges_fname_hor, edges_fname_original_hor,m_pic,n_pic);
% write out data to a comma separated value (csv) file that Excel can read
csvwrite('C:\Documents and Settings\Dudu\Desktop\project logs\surface correction trnasform  matrices\H.csv', H_matrix);
sprintf('successfully write matrix  H')
H_matrix= csvread('C:\Documents and Settings\Dudu\Desktop\project logs\surface correction trnasform  matrices\H.csv')
sprintf('finished read matrix  H')



V_transposed_matrix=surface_edges_mapping_and_dev_calc(edges_fname_ver_t,edges_fname_original_ver_t,m_pic,n_pic);
% write out data to a comma separated value (csv) file that Excel can read
csvwrite('C:\Documents and Settings\Dudu\Desktop\project logs\surface correction trnasform  matrices\V_T.csv',V_transposed_matrix);
sprintf('successfully write matrix  V transposed')
% read a file from csv format into MATLAB
V_transposed_matrix=csvread('C:\Documents and Settings\Dudu\Desktop\project logs\surface correction trnasform  matrices\V_T.csv')
sprintf('finished read matrix V transposed')

V_matrix=[];
V_matrix=[V_matrix;V_transposed_matrix'];%TRANSPOSING BACK THE CORRECTION SURFACE MATRIX OF THE TRAMSPOSED VERTICAL CURVES

 %******************STAGE 3:USING THE TRANSFORM H & V MATRICES TO RELOCATE THE ORIGINAL PIXELS OF THE INPUT PICTURE  AND SET IT'S DATA  ********************************** 
  
 %preparing the updating check of output matrix   pixels in order to avoid
  %overriding an allready updated data
    for i=1:m_pic
         for j=1:n_pic
             visit_output_matrix(i,j)=false;
         end
    end
    
 %PIC MATRIX SHOULD BE SAME SIZE AS OUR H & V RELOCATION MATRICES 
 
     for i=1:m_pic
          for j=1:n_pic
              
              target_pixel_i=i;
              target_pixel_j=j;
              
              vertical_step=H_matrix(i,j);%step_size_i_to_target_pixel
              horizontal_step=V_matrix(i,j);%step_size_j_to_target_pixel
            %if1
             if((i+vertical_step>=1 && i+vertical_step<=m_pic) &&(j+horizontal_step>=1 && j+horizontal_step<=n_pic) )% case a legal target pixel
                  target_pixel_i=i+vertical_step;
                  target_pixel_j=j+horizontal_step;
                  sprintf('setting targetpixel(i=%d,j=%d)', target_pixel_i,target_pixel_j)
                 if(visit_output_matrix(target_pixel_i,target_pixel_j)==false)%if2
                    %total_pic_out(target_pixel_i,target_pixel_j)=input_picture_matrix(i,j);
                    %horizontal_pic_out(target_pixel_i,j)=input_picture_matrix(i,j);
                     visit_output_matrix(target_pixel_i,target_pixel_j)=true;
                      total_pic_out(target_pixel_i,target_pixel_j)=input_picture_matrix(i,j);
                      %just for RT showing it's creation progress
                imwrite(total_pic_out ,'C:\Documents and Settings\Dudu\Desktop\project logs\post deviation correction data\hor_ver_pic_correction.tif');
                     
                 end%if2
       
             end  %if1
  
          end%for2
    end%for1

     missing_data_pic_name='C:\Documents and Settings\Dudu\Desktop\project logs\post deviation correction data\hor_ver_pic_correction.tif';
    imwrite(total_pic_out , missing_data_pic_name);
    
    %  *********************STAGE 4:DATA LOSS SMOTHING /CORRECTION BY AVERAGING EMPTY DATA PIXEL ENVIRONMENT AND SET AN AVG DATA INTO IT********  
    restored_data_output_picture=[];
    %RESTORING DATA BY USING THE FUNCTION missing_pixels_fill_in:
    restored_data_output_picture=[  restored_data_output_picture;missing_pixels_fill_in(missing_data_pic_name)];
    final_out_pic_name= 'C:\Documents and Settings\Dudu\Desktop\project logs\final output data\restored_data_pic_out.tif'
    imwrite(restored_data_output_picture,final_out_pic_name); 
    %imshow(restored_data_output_picture);      
end