function [ans]=missing_pixels_fill_in(missing_data_pic_name)
    %missing_data_pic_name='C:\Documents and Settings\Dudu\Desktop\project logs\post deviation correction data\hor_ver_pic_correction.tif';
    missing_data_img=imread(missing_data_pic_name);
    [m,n]=size(missing_data_img);
    black=80;
    ws=3;%window size
    for i=1:m%for m
        for j=1:n%for n
            current_pixel_intensity=missing_data_img(i,j);
            sprintf('CURR CHECKED PIXEL IS :  pixel(i=%d,j=%d)',i,j)
            
            if(current_pixel_intensity<=black)%if0 %checks neighbours only for a missing data pixels
                data_neighbour_counter=0;
                data_neighbours_intensity_sum=0;%init summation value of data neighbours intensity
                n_count=0;
               
                
                for y=-ws:ws%y is the index over the lines
                    for x=-ws:ws% x is the index over the coloumns
                        n_count=n_count+1%inc' neighbours counter    
                        %neighbour location in the matrix
                        n_i=i-y;%neighbour i index
                        n_j=j-x;%neighbour j index
                        sprintf('neighbour Num=%d         n_pix(%d,%d)    of      pixel(i=%d,j=%d)',n_count,n_i,n_j,i,j)
                       
                 
                        if( (n_i~=i || n_j~=j)  && (n_i>=1 && n_i<=m) && (n_j>=1 &&n_j<=n ) )%if1   //filtering out of bounds neighbours and current pixel(i,j)
                            
                                curr_neighbour_pixel_intensity=missing_data_img(n_i,n_j);
                                
                                if(curr_neighbour_pixel_intensity>100)
                                    data_neighbour_counter=data_neighbour_counter+1;
                                    data_neighbours_intensity_sum=data_neighbours_intensity_sum+curr_neighbour_pixel_intensity;
                                end
                        %no inolvment/contribution of Object pixel probability!!!!
                        end%if1
                        
                    end%for x
                end%fory   
                
        %****************************2.0 NEIGHBOURS LOOP ENDED***************************
        
                %averaging the  data neighbours intensity
                if(data_neighbour_counter~=0)%if2
                        avg_data_neigbours_intensity=data_neighbours_intensity_sum/data_neighbour_counter;
                        sprintf('avg intensity of pixels=%d     intensity sum=%d        number_of_data_neighbours=%d',avg_data_neigbours_intensity,data_neighbours_intensity_sum,data_neighbour_counter)
                        current_pixel_intensity=avg_data_neigbours_intensity
                        missing_data_img(i,j)=current_pixel_intensity;
                        sprintf('SUCCESS:missing data pixel restored succesfully')
                end%if2
            else
                 sprintf('NO_NEED:this is a data pixel no restoration of data needed')
         end%if0
         
         %imshow(missing_data_img);
         
       imwrite(missing_data_img ,'C:\Documents and Settings\Dudu\Desktop\project logs\final output data\restored_data_pic_out.tif')  
         
        end% end l
    end%end m
    
    %imwrite(missing_data_img ,'C:\Documents and Settings\Dudu\Desktop\project logs\restored_data_pic_out.tif'); 
    ans=missing_data_img;
    
end